package	jp.co.sds_corp.fixconnect.message;

import	java.io.Serializable;

/**
* 固定値として使用するタグの定義です。
*/
public class Tag implements Serializable
{
	/** serialVersionUID */
    private static final long serialVersionUID = 1L;

	// FIX header
	public static final Tag BeginString = new Tag( 8, "BeginString" );
	public static final Tag BodyLength = new Tag( 9, "BodyLength" );
	public static final Tag MsgType = new Tag( 35, "MsgType" );
	public static final Tag MsgSeqNum = new Tag( 34, "MsgSeqNum" );
	public static final Tag SendingTime = new Tag( 52, "SendingTime" );

	// FIX trailer
	public static final Tag CheckSum = new Tag( 10, "CheckSum" );

	int	id;	// タグのID
	String	name;	// タグ名

	/**
	* タグを定義します。
	* @param	id		タグID
	* @param	name	タグ名
	*/
	public Tag( int id, String name ) {
		this.id = id;
		this.name = name;
	}

	public String toString() {
		String ret = name + "(" + id + ")";
		return ret;
	}

	/**
	* タグのIDを取得します。
	* @return	タグのID
	*/
	public int getId() {
		return id;
	}

	/**
	* タグ名を取得します。
	* @return   タグ名
	*/
	public String getName() {
		return name;
	}

}
