package	jp.co.sds_corp.fixconnect.store;

import	java.io.BufferedReader;
import	java.io.FileNotFoundException;
import	java.io.FileReader;
import	java.io.FileWriter;
import	java.io.PrintWriter;

import	jp.co.sds_corp.fixconnect.message.FIXMessage;
import	jp.co.sds_corp.fixconnect.transport.FIXSession;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

/**
* シーケンス番号のみを保存します。
*/
public class SequenceStore extends AbstractStore
{
	static final CmnLogger logger = CmnLogFactory.getLogger();
	String	filename;

	public void init( IConfiguration config ) throws Exception {
		setSendSeqNum( 0 );
		setRecvSeqNum( 0 );
		filename = config.getAttributes().get( "file" );
		try {
			readFile( filename );
		} catch ( FileNotFoundException ex ) {
			logger.debug( this, "file not found. create[" + filename + "]" );
		}
		logger.debug( this, "initialized."
			+ " send seq=" + getSendSeqNum() + " recv seq=" + getRecvSeqNum() );
	}

	void readFile( String filename ) throws Exception {
		BufferedReader rd = null;
		String line;
		try {
			rd = new BufferedReader( new FileReader( filename ));
			line = rd.readLine();
			int send = Integer.valueOf( line ).intValue();
			line = rd.readLine();
			int recv = Integer.valueOf( line ).intValue();
			setSendSeqNum( send );
			setRecvSeqNum( recv );
		} catch ( Exception ex ) {
			throw( ex );
		} finally {
			try {
				rd.close();
			} catch ( Exception ex ) {
			}
		}
	}

	void saveFile( String filename ) throws Exception {
		PrintWriter wr = null;
		try {
			wr = new PrintWriter( new FileWriter( filename ));
			wr.println( getSendSeqNum() );
			wr.println( getRecvSeqNum() );
			wr.flush();
		} catch ( Exception ex ) {
		} finally {
			try {
				wr.close();
			} catch ( Exception ex ) {
			}
		}
	}

	public void save( FIXSession session, FIXMessage msg ) throws Exception {
		saveFile( filename );
	}

	public FIXMessage load( FIXSession session, int seqNo ) throws Exception {
		return null;
	}

	public void close() throws Exception {
		saveFile( filename );
	}

}
