package	jp.co.sds_corp.fixconnect.transport;

import	java.util.List;
import	java.util.Vector;
import	jp.co.sds_corp.fixconnect.FIXException;

public class TransportSupport
{
	List<ITransportEventListener> vecLsn = new Vector<ITransportEventListener>();

	public TransportSupport() {
	}

	public void addEventListener( ITransportEventListener l ) {
		vecLsn.add( l );
	}

	public boolean removeEventListener( ITransportEventListener l ) {
		return vecLsn.remove( l );
	}

	public void fireEventOccurred( FIXSession session, TransportEvent ev ) {
		ev.setSession( session );
		fireEventOccurred( ev );
	}

	public void fireEventOccurred( FIXSocket sock, TransportEvent.Type type ) {
		TransportEvent ev = new TransportEvent( sock, type );
		fireEventOccurred( ev );
	}

	public void fireEventOccurred( TransportEvent ev ) {
		for ( ITransportEventListener l : vecLsn ) {
			l.onEvent( ev );
		}
	}

	public void fireExceptionOccurred( FIXException ex ) {
		for ( ITransportEventListener l : vecLsn ) {
			l.onException( ex );
		}
	}

}
